unit mekGram;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, StdCtrls, Buttons, Mask, ExtCtrls, DBCtrls, DB, DBTables,
  DBCGrids;

type
  TfMekGram = class(TForm)
    Panel1: TPanel;
    Label2: TLabel;
    Label1: TLabel;
    Label3: TLabel;
    eUzvards: TEdit;
    eVards: TEdit;
    eNosaukums: TEdit;
    Button1: TBitBtn;
    sGramatas: TDataSource;
    DBCtrlGrid1: TDBCtrlGrid;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    Label4: TLabel;
    Label5: TLabel;
    Button2: TButton;
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure dbgPersDblClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
  procedure mekletGram;

  public


  end;

var
  fMekGram: TfMekGram;

implementation

uses datuModulis;

//uses DM;

{$R *.DFM}


procedure TfMekGram.Button2Click(Sender: TObject);
begin
//showmessage(DM.qGramatasFind
DM.tPersonas.Locate('PERSONA_ID', DM.qGramatasFind.FieldByName('GRAMATA_ID').Value, [loCaseInsensitive,loPartialKey])

end;

procedure TfMekGram.FormClose(Sender: TObject; var Action: TCloseAction);
begin
DM.tPersonas.Locate('PERSONA_ID', DM.tPersLook.FieldByName('PERSONA_ID').Value, [loCaseInsensitive,loPartialKey])

end;

procedure TfMekGram.dbgPersDblClick(Sender: TObject);
begin
close
end;


procedure TfMekGram.mekletGram;
var
   vMEkOpc        : TLocateOptions;
   vSQLTeksts     : String;
begin
   vMekOpc := [loPartialKey,loCaseInsensitive];
   if ( eUzvards.Text <> '' ) then begin
      vSQLTeksts := 'UZVARDS = ' + eUzvards.Text;
   end;
   if ( eVards.Text <> '' ) then begin
      vSQLTeksts := vSQLTeksts + ' AND VARDS = ' + eVards.Text;
   end;
   if ( eNosaukums.Text <> '' ) then begin
      vSQLTeksts := vSQLTeksts + ' AND NOSAUKUMS = ' + eNosaukums.Text;
   end;

   if vSQLTeksts <> '' then begin
      vSQLTeksts := 'SELECT * FROM PERSONAS' + vSQLTeksts;
      DM.qTemp.Close;
      DM.qTemp.SQL.Clear;
      DM.qTemp.SQL.Add( vSQLTeksts );
      DM.qTemp.Open;
      if DM.qTemp.Fields[0].Value = Null
         then ShowMessage( 'Pieprast bve nav atrasta' )
         else if DM.tPersonas.Locate( 'BUVE_ID', DM.qTemp.Fields[0].Value, vMekOpc )
            then Close;
   end
   else
      ShowMessage('Jaizpilda meklanas nosacjums.');
end;





procedure TfMekGram.Button1Click(Sender: TObject);
var
     vSql, vWhere: string;

begin
vSql := 'SELECT GRAMATA_ID,NOSAUKUMS,UZVARDS,VARDS' +
        ' FROM GRAMATAS,AUTORI' +
        ' WHERE AUTORI.AUTORS_ID=GRAMATAS.AUTORS_FK AND UZVIETAS=TRUE';

// Gramatas nos
if eNosaukums.Text <> '' then
   vWhere := 'AND GRAMATAS.NOSAUKUMS LIKE '''+ eNosaukums.Text+'''';

// Autora uzvards
if eUzvards.Text <> '' then
   vWhere := ' AND AUTORI.UZVARDS LIKE '''+ eUzvards.Text+'''';

// Autora vards
if eVards.Text <> '' then
   vWhere := vWhere + ' AND AUTORI.VARDS LIKE '''+ eVards.Text+'''';

   if vSql <> '' then
      vSql := vSql+vWhere;

   DM.qGramatasFind.Close;
   DM.qGramatasFind.Sql.Clear;
   DM.qGramatasFind.Sql.Add( vSql );
   DM.qGramatasFind.Open;




end;




procedure TfMekGram.FormActivate(Sender: TObject);
var
   vSql: string;
begin
vSql := 'SELECT GRAMATA_ID,NOSAUKUMS,UZVARDS' +
        ' FROM GRAMATAS,AUTORI' +
        ' WHERE AUTORI.AUTORS_ID=GRAMATAS.AUTORS_FK ';

   DM.qTemp.Close;
   DM.qTemp.Sql.Clear;
   DM.qTemp.Sql.Add( vSql );
   DM.qTemp.Open;

end;

end.
