unit mekPers;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, StdCtrls, Buttons, Mask, ExtCtrls;

type
  TfMekPers = class(TForm)
    dbgPers: TDBGrid;
    cField: TComboBox;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Bevel1: TBevel;
    procedure cFieldChange(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure dbgPersDblClick(Sender: TObject);
  private
  function getFieldName(vMes: string): string;

  public


  end;

var
  fMekPers: TfMekPers;

implementation

uses datuModulis;

//uses DM;

{$R *.DFM}

function TfMekPers.getFieldName(vMes: string): string;
begin

     getFieldName := vMes;
     if vMes = 'Kods' then getFieldName := 'persona_id'
     else if vMes = 'Uzvrds' then getFieldName := 'Uzvards'
     else if vMes = 'Vrds' then getFieldName := 'Vards'

end;

procedure TfMekPers.cFieldChange(Sender: TObject);
begin
  { Make the field we're locating in the leftmost field. }

  DM.tPersLook.FieldByName(getFieldName(cField.Text)).Index := 0;

end;

procedure TfMekPers.Edit1Change(Sender: TObject);
var
  b: Boolean;
  vFieldName, mes: string;
  vNum, vCode: integer;
begin

  if trim(edit1.Text) = '' then begin
     DM.tPersLook.Filtered := False;
     exit;
  end;


  if cField.text = 'Kods' then begin
        //Parkeram kludu
        try
           mes := intToStr(strToInt(Edit1.text));
        except
           raise exception.create('Ievadi skaitli !');
        end;
  end;

  vFieldName := getFieldName(cField.Text);

  with DM.tPersLook do
  begin

      b := (Locate(vFieldName, Edit1.Text,[loCaseInsensitive,loPartialKey]));

      if b then
      begin
        { Get an expression such as State = 'CA'. }
        Filter := vFieldName + ' = ' + '''' + Edit1.Text + '''';
        Filtered := True;
        if RecordCount = 0 then {Filter is possibly too restrictive}
          Filter := vFieldName + ' >= ' + '''' + Edit1.Text + '''';
    end
      else
        Filtered := False;
    end;
    Refresh;

  end;

procedure TfMekPers.Button2Click(Sender: TObject);
begin
close;
end;

procedure TfMekPers.FormClose(Sender: TObject; var Action: TCloseAction);
begin
DM.tPersonas.Locate('PERSONA_ID', DM.tPersLook.FieldByName('PERSONA_ID').Value, [loCaseInsensitive,loPartialKey])

end;

procedure TfMekPers.dbgPersDblClick(Sender: TObject);
begin
close
end;

end.
