unit datuModulis;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DB, DBTables;

type
  TDM = class(TDataModule)
    tAutori: TTable;
    db: TDatabase;
    tPersonas: TTable;
    tUzskaite: TTable;
    tGramatas: TTable;
    qAutors: TQuery;
    qAutorsAUTORS_ID: TIntegerField;
    qAutorsExpr1001: TStringField;
    tPersonasuzvards: TStringField;
    tPersonasvards: TStringField;
    tPersonasadrese: TStringField;
    tPersonastelefons: TStringField;
    qTemp: TQuery;
    tPersonaspersona_id: TIntegerField;
    tUzskaitepersona_fk: TIntegerField;
    tUzskaitegramata_fk: TIntegerField;
    tUzskaiteizdosanas_dat: TDateTimeField;
    tUzskaitenodosanas_dat: TDateTimeField;
    tUzskaitePersona: TStringField;
    qPersona: TQuery;
    sGramatas: TDataSource;
    sAutori: TDataSource;
    sPersonas: TDataSource;
    sUzskaite: TDataSource;
    sPersona: TDataSource;
    qPersonaPERSONA_ID: TIntegerField;
    qPersonaExpr1001: TStringField;
    qPanemtasGram: TQuery;
    sPanemtasGram: TDataSource;
    tAutoriLook: TTable;
    IntegerField1: TIntegerField;
    StringField1: TStringField;
    StringField2: TStringField;
    sAutoriLook: TDataSource;
    tGramLook: TTable;
    IntegerField2: TIntegerField;
    StringField3: TStringField;
    SmallintField1: TSmallintField;
    IntegerField3: TIntegerField;
    BooleanField1: TBooleanField;
    StringField4: TStringField;
    sGramLook: TDataSource;
    sPersLook: TDataSource;
    tPersLook: TTable;
    IntegerField4: TIntegerField;
    StringField5: TStringField;
    StringField6: TStringField;
    StringField7: TStringField;
    StringField8: TStringField;
    tGramatasgramata_id: TIntegerField;
    tGramatasnosaukums: TStringField;
    tGramatasizdosanas_dat: TSmallintField;
    tGramatasautors_fk: TIntegerField;
    tGramatasirUzvietas: TBooleanField;
    tGramatasAutors: TStringField;
    sTemp: TDataSource;
    tAutoriautors_id: TIntegerField;
    tAutoriuzvards: TStringField;
    tAutorivards: TStringField;
    qGramatasFind: TQuery;
    tGramatasUzvietas: TTable;
    IntegerField5: TIntegerField;
    StringField9: TStringField;
    SmallintField2: TSmallintField;
    IntegerField6: TIntegerField;
    BooleanField2: TBooleanField;
    procedure tGramatasirUzvietasGetText(Sender: TField; var Text: string;
      DisplayText: Boolean);
    procedure tGramatasirUzvietasSetText(Sender: TField;
      const Text: string);
    procedure tGramatasNewRecord(DataSet: TDataSet);
    procedure tAutoriNewRecord(DataSet: TDataSet);
    procedure tPersonasNewRecord(DataSet: TDataSet);
    procedure tAutoriAfterPost(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
    function Sequence(DataSet: TDataSet): String;
  end;

var
  DM: TDM;

implementation

uses gramatas, personas, uzskaite, autori;

{$R *.DFM}

function TDM.Sequence(DataSet: TDataSet): String;
var
      vKd_New : String[4];
begin
   qGramatasFind.Close;
   qTemp.SQL.Clear;
   qTemp.SQL.Add('SELECT MAX(' + DataSet.Fields[0].FieldName + ') FROM ' +
      (DataSet as TTable).TableName);
   qTemp.Open;
   if qTemp.Fields[0].Value = Null
      then vKd_New := '1'
      else vKd_New := IntToStr(StrToInt( qTemp.Fields[0].Value ) + 1);
    Sequence := vKd_New;

end;





procedure TDM.tGramatasirUzvietasGetText(Sender: TField; var Text: string;
  DisplayText: Boolean);
begin
   if Sender.Value = 'Yes' then Text := 'J'
   else Text := 'N';
   DisplayText := True;

end;

procedure TDM.tGramatasirUzvietasSetText(Sender: TField;
  const Text: string);
begin
   if Text = 'J' then Sender.Value := 'Yes'
   else Sender.Value := 'No';

end;

procedure TDM.tGramatasNewRecord(DataSet: TDataSet);
begin
   DataSet.Fields[0].Value := Sequence(DataSet);
   DataSet['irUzvietas'] := True;
end;

procedure TDM.tAutoriNewRecord(DataSet: TDataSet);
begin
   DataSet.Fields[0].Value := Sequence(DataSet);
end;


procedure TDM.tPersonasNewRecord(DataSet: TDataSet);
begin
   DataSet.Fields[0].Value := Sequence(DataSet);
end;


procedure TDM.tAutoriAfterPost(DataSet: TDataSet);
begin
  qAutors.Close;
  qAutors.Open;
end;

end.
